from cpl_core.application import ApplicationExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC

from bot_api.route.route import Route
from bot_core.configuration.feature_flags_enum import FeatureFlagsEnum
from bot_core.configuration.feature_flags_settings import FeatureFlagsSettings


class AppApiExtension(ApplicationExtensionABC):
    def __init__(self):
        ApplicationExtensionABC.__init__(self)

    async def run(self, config: ConfigurationABC, services: ServiceProviderABC):
        feature_flags: FeatureFlagsSettings = config.get_configuration(FeatureFlagsSettings)
        if not feature_flags.get_flag(FeatureFlagsEnum.api_module):
            return

        Route.init_authorize()
