from typing import Optional

import discord
from cpl_query.extension import List

from modules.base.model.active_event import ActiveEvent


class EventService:
    def __init__(self):
        self._active_events = List(ActiveEvent)

    def add_event(self, event: ActiveEvent):
        if self._active_events.contains(event):
            return

        self._active_events.add(event)

    def get_active_event(self, event: discord.ScheduledEvent) -> Optional[ActiveEvent]:
        return self._active_events.where(lambda x: x.event.id == event.id).single_or_default()

    def get_active_event_by_channel_id(self, channel_id: int) -> Optional[ActiveEvent]:
        return self._active_events.where(
            lambda x: x.event.channel is not None and x.event.channel.id == channel_id
        ).single_or_default()

    def remove_event(self, event: ActiveEvent):
        if not self._active_events.contains(event):
            return

        self._active_events.remove(event)
