import discord
from cpl_discord.events import OnMemberJoinABC

from bot_core.helper.event_checks import EventChecks
from bot_core.logging.message_logger import MessageLogger
from modules.level.service.level_service import LevelService


class LevelOnMemberJoinEvent(OnMemberJoinABC):
    def __init__(self, logger: MessageLogger, level: LevelService):
        OnMemberJoinABC.__init__(self)
        self._logger = logger
        self._level = level

    @EventChecks.check_is_ready()
    async def on_member_join(self, member: discord.Member):
        self._logger.debug(__name__, f"Module {type(self)} started")
        await self._level.check_level(member)
